# Copyright (c) 2014 Adafruit Industries
# Author: Tony DiCola
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.

# Modified : Illya Tsemenko

import unittest

import Adafruit_GPIO as GPIO
from spi_bb import BitBang

from MockGPIO import MockGPIO

#  SSD 1362 controller
# some help https://github.com/afiskon/stm32-ssd1306/blob/master/ssd1306/ssd1306.c

class oled_bb_spi():
    def __init__():
        """Initialize OLED over bb 3-wire SPI"""
        gpio = MockGPIO()
        oled = BitBang(gpio, 1, 2, 3, 4)

    def assert_reset():

    def deassert_reset():

    def boot_oled():
        gpio = MockGPIO()
        device = SPI.BitBang(gpio, 1, 2, 3, 4)
        
        deassert_reset()
        time.sleep(0.5)
        deassert_reset()
        time.sleep(0.5)
        device.write_9b([0x1F], 0, assert_ss=True)
        device.write_9b([0XFD], 0, assert_ss=True) #Set Command Lock
        device.write_9b([0X12], 0, assert_ss=True) #(12H=Unlock,16H=Lock)
        device.write_9b([0XAE], 0, assert_ss=True) #Display OFF(Sleep Mode)
        device.write_9b([0X15], 0, assert_ss=True) #Set column Address
        device.write_9b([0X00], 0, assert_ss=True) #Start column Address
        device.write_9b([0X7F], 0, assert_ss=True) #End column Address
        device.write_9b([0X75], 0, assert_ss=True) #Set Row Address
        device.write_9b([0X00], 0, assert_ss=True) #Start Row Address
        device.write_9b([0X3F], 0, assert_ss=True) #End Row Address
        device.write_9b([0X81], 0, assert_ss=True) #Set contrast
        device.write_9b([0x2f], 0, assert_ss=True) #
        device.write_9b([0XA0], 0, assert_ss=True) #Set Remap
        device.write_9b([0Xc3], 0, assert_ss=True) #
        device.write_9b([0XA1], 0, assert_ss=True) #Set Display Start Line
        device.write_9b([0X00], 0, assert_ss=True) #
        device.write_9b([0XA2], 0, assert_ss=True) #Set Display Offset
        device.write_9b([0X00], 0, assert_ss=True) #
        device.write_9b([0XA4], 0, assert_ss=True) #Normal Display
        device.write_9b([0XA8], 0, assert_ss=True) #Set Multiplex Ratio
        device.write_9b([0X3F], 0, assert_ss=True) #
        device.write_9b([0XAB], 0, assert_ss=True) #Set VDD regulator
        device.write_9b([0X01], 0, assert_ss=True) #Regulator Enable
        time.sleep(1)
        device.write_9b([0XAD], 0, assert_ss=True) #External /Internal IREF Selection
        device.write_9b([0X8E], 0, assert_ss=True) #
        device.write_9b([0XB1], 0, assert_ss=True) #Set Phase Length
        device.write_9b([0X22], 0, assert_ss=True) #
        device.write_9b([0XB3], 0, assert_ss=True) #Display clock Divider
        device.write_9b([0XA0], 0, assert_ss=True) #
        device.write_9b([0XB6], 0, assert_ss=True) #Set Second pre-charge Period
        device.write_9b([0X04], 0, assert_ss=True) #
        device.write_9b([0XB9], 0, assert_ss=True) #Set Linear LUT
        device.write_9b([0XBc], 0, assert_ss=True) #Set pre-charge voltage level
        device.write_9b([0X10], 0, assert_ss=True) #0.5*Vcc
        device.write_9b([0XBD], 0, assert_ss=True) #Pre-charge voltage capacitor Selection
        device.write_9b([0X01], 0, assert_ss=True) #
        device.write_9b([0XBE], 0, assert_ss=True) #Set COM deselect voltage level
        device.write_9b([0X07], 0, assert_ss=True) #0.82*Vcc
        device.write_9b([0XAF], 0, assert_ss=True) #Display ON


oled_bb_spi.boot_oled()